function Cesty = cplex10(Graf, Redukovany_graf)


[pocetVrcholov, pv] = size(Graf);
pocetHran = 0;
pocetVybratychHran = 0;

pocetCiest = 10;

vybrateMatica = zeros(pocetVrcholov, pocetVrcholov);

X_E = [];
Y_E = [];

X_R = [];
Y_R = [];

for i=1:pocetVrcholov    
    for j=1:pocetVrcholov
        zobral = 0;        
        
        if (Redukovany_graf(i,j)==1)
            pocetVybratychHran = pocetVybratychHran + 1;
            X_R = [X_R, i];
            Y_R = [Y_R, j];
            vybrateMatica(i,j) = pocetVybratychHran;
            zobral = 1;
        end        
        
        if ((Graf(i,j)==1) && (zobral == 0))
            pocetHran = pocetHran + 1; 
            X_E = [X_E, i];
            Y_E = [Y_E, j];
        end       
        
        zobral = 0;
    end        
end

pocetPremennych = (pocetVrcholov + pocetHran + pocetVybratychHran) * pocetCiest;
f = zeros(1, pocetPremennych);

% ucelova fcia
for i=1:pocetCiest
    for v=1:pocetVrcholov                      
        P = 0;
        for j=1:pocetVrcholov            
            if (Redukovany_graf(j, v)==1)                
                P = P + 1;
            end 
        end
        if (P == 0)
            blok = (pocetVybratychHran + pocetHran + pocetVrcholov) * (i-1);
            vrchol = blok + pocetVybratychHran + pocetHran + v;
            f(1,vrchol) = 1;
        end                        
        
    end
end

A = [];
b = [];

Aeq = [];
beq = [];

% podmienka 1
for i=1:(pocetCiest-1)
    Av = zeros(size(f));
    for v=1:pocetVrcholov
        blok = (pocetVybratychHran + pocetHran + pocetVrcholov) * (i-1);
        vrchol = blok + pocetVybratychHran + pocetHran + v;               
        Av(1,vrchol) = -v;
        
        blok = (pocetVybratychHran + pocetHran + pocetVrcholov) * i;
        vrchol = blok + pocetVybratychHran + pocetHran + v;               
        Av(1,vrchol) = v;
    end 
    A = [A; Av];
    b = [b; 0];
end

%podmienka 2 
for i=1:pocetCiest   
    for v=1:pocetVrcholov
        Av = zeros(size(f));
        P = 0;        
        blok = (pocetVybratychHran + pocetHran + pocetVrcholov) * (i-1);
        vr = blok + pocetVybratychHran + pocetHran + v;
        for j=1:pocetVrcholov
            if (Redukovany_graf(j,v)==1)                
                P = P + 1;                
                index = vybrateMatica(j,v) + blok;
                Av(1, index) = -1;
            end                 
        end
        if (P > 0)            
            Av(1, vr) = 1;
            Aeq = [Aeq; Av];
            beq = [beq; 0];
        end
    end
end

% podmienka 3
for i=1:pocetCiest   
    for v=1:pocetVrcholov
        Av = zeros(size(f));
        P = 0;        
        blok = (pocetVybratychHran + pocetHran + pocetVrcholov) * (i-1);
        vr = blok + pocetVybratychHran + pocetHran + v;        
        for j=1:pocetVrcholov
            if (Redukovany_graf(v, j)==1)                
                P = P + 1;
                index = blok + vybrateMatica(v,j);
                Av(1, index) = -1;
            end                 
        end
        if (P > 0)            
            Av(1, vr) = 1;
            Aeq = [Aeq; Av];
            beq = [beq; 0];
        end
    end
end

% podmienka 4
for i=1:pocetCiest
    Av = zeros(size(f));
    for v=1:pocetVrcholov        
        P = 0;
        for j=1:pocetVrcholov            
            if (Redukovany_graf(j, v)==1)                
                P = P + 1;
            end 
        end
        if (P == 0)
            blok = (pocetVybratychHran + pocetHran + pocetVrcholov) * (i-1);
            vr = blok + pocetVybratychHran + pocetHran + v;
            Av(1,vr) = 1;
        end       
    end
    A = [A; Av];
    b = [b; 1];
end

% podmienka 5
for i=1:pocetCiest
    Av = zeros(size(f));
    for v=1:pocetVrcholov        
        P = 0;
        for j=1:pocetVrcholov            
            if (Redukovany_graf(v, j)==1)                
                P = P + 1;
            end 
        end
        if (P == 0)
            blok = (pocetVybratychHran + pocetHran + pocetVrcholov) * (i-1);
            vr = blok + pocetVybratychHran + pocetHran + v;
            Av(1,vr) = 1;
        end       
    end
    A = [A; Av];
    b = [b; 1];
end

% podmienka 6
for i=1:pocetCiest
    for e=1:pocetHran
        blok = (pocetVybratychHran + pocetHran + pocetVrcholov) * (i-1);
        u = blok + pocetVybratychHran + pocetHran + X_E(1,e);
        v = blok + pocetVybratychHran + pocetHran + Y_E(1,e);        
        Av = zeros(size(f));        
        hr = blok + pocetVybratychHran + e;
        Av(1, hr) = 1;
        Av(1,u) = -0.5;
        Av(1,v) = -0.5;
        A = [A; Av];
        b = [b; 0];
    end
end

% podmienka 7
for e=1:pocetVybratychHran
    Av = zeros(size(f));    
    for i=1:pocetCiest
        blok = (pocetVybratychHran + pocetHran + pocetVrcholov) * (i-1);
        hr = blok + e;
        Av(1,hr) = -1;
    end
    A = [A; Av];
    b = [b; -1];
end

% podmienka 8
for e=1:pocetHran
    Av = zeros(size(f));    
    for i=1:pocetCiest
        blok = (pocetVybratychHran + pocetHran + pocetVrcholov) * (i-1);
        hr = blok + pocetVybratychHran + e;
        Av(1,hr) = -1;
    end
    A = [A; Av];
    b = [b; -1];
end

fileID = fopen('example.lp', 'w');
fprintf(fileID, '%6s\n', 'Minimize');

riadok = '0';

fprintf(fileID, '%6s\n', 'Subject To');

[pr, ps] = size(A);

for i=1:pr
    riadok = '';
    for j=1:ps
        r = '';
        meno = strcat('x', num2str(j));
        if (A(i,j)>=0)
            r = ['+ ', num2str(A(i,j)), ' ', meno];            
        else
            r = [num2str(A(i,j)), ' ', meno];
        end
        riadok = [riadok, ' ', r]; 
    end        
    riadok = [riadok, ' <= ', num2str(b(i,1))];
    fprintf(fileID, '\t%s\n', riadok);
end

[pr, ps] = size(Aeq);

for i=1:pr
    riadok = '';
    for j=1:ps
        r = '';
        meno = strcat('x', num2str(j));
        if (Aeq(i,j)>=0)
            r = ['+ ', num2str(Aeq(i,j)), ' ', meno];
        else
            r = [num2str(Aeq(i,j)), ' ', meno];
        end
        riadok = [riadok, ' ', r]; 
    end        
    riadok = [riadok, ' = ', num2str(beq(i,1))];
    fprintf(fileID, '\t%s\n', riadok);
end

fprintf(fileID, '%6s\n', 'Bounds');

for i=1:pocetPremennych
    riadok = '';
    meno = strcat('x', num2str(i));    
    riadok = [meno, '<=1'];   
    fprintf(fileID, '\t%s\n', riadok);
end

fprintf(fileID, '%6s\n', 'Integer');

for i=1:pocetPremennych    
    meno = strcat('x', num2str(i));           
    fprintf(fileID, '\t%s\n', meno);
end

fprintf(fileID, '%6s\n', 'End');
fclose(fileID);

dlmwrite('maticaCplex.txt', pocetCiest, 'newline', 'pc', 'delimiter','\t');
dlmwrite('maticaCplex.txt', pocetVybratychHran, '-append', 'newline', 'pc', 'delimiter','\t');
dlmwrite('maticaCplex.txt', pocetHran, '-append', 'newline', 'pc', 'delimiter','\t');
dlmwrite('maticaCplex.txt', pocetVrcholov, '-append', 'newline', 'pc', 'delimiter','\t');
dlmwrite('maticaCplexX.txt', X_R, '-append', 'newline', 'pc', 'delimiter','\t');
dlmwrite('maticaCplexY.txt', Y_R, '-append', 'newline', 'pc', 'delimiter','\t');

Cesty = A;